*! version 1.0.1  28feb2006
program _mds_s2d
	version 9

	#del ;
	syntax  anything(id=matrix name=m) 
	[, 
		ONEminus 
		STandard 
		FIXDiagonal
	] ;
	#del cr
		
	confirm matrix `m' 
	assert  issym(`m')
	
	local method `oneminus' `standard'
	if `:list sizeof method' == 0 {
		local method standard
	}
	opts_exclusive "`method'"

// beware : code should keep row and column stripes intact

	if "`fixdiagonal'" != "" { 
		mata : UnitDiag("`m'")
	}	
	
	if "`method'" == "oneminus" {
		// code allows missing values
		matrix `m' = J(rowsof(`m'),colsof(`m'),1) - `m'
	}
	else if "`method'" == "standard" { 
		mata : Standard("`m'")
	}
	else { 
		_stata_internalerror
	}	
end


// converts in-situ a matrix of similarities to dissimilarities
// this command requires MATA for efficiency
//
// returns MOUT[i,j] = sqrt(M[i,i] - 2*M[i,j] + M[j,j])
//
mata: 
void function Standard(string scalar mname)
{
	real matrix  M
	
	M = st_matrix(mname)
	st_replacematrix(mname, sqrt(-2*M :+ diagonal(M) :+ diagonal(M)'))
}


void function UnitDiag(string scalar mname)
{
	real scalar  i, n
	real matrix  M
	
	M = st_matrix(mname)
	n = min((cols(M),rows(M)))
	for (i=1; i<=n; i++) { 
		if (M[i,i] >= .) {
			M[i,i] = 1
		}	
	}	
	st_replacematrix(mname, M)
}
end
