*! version 1.0.3  29jun2006
program _svy_check_cmdopts, sclass
	// Common options that -svy- can take over; they are most likely
	// ignored anyway.
	version 9
	syntax name(name=cmdname) [, * ]

	// the following options, when specified, will result in an error msg
	local badopts	SUBpop(passthru)	///
			Cluster(passthru)	///
			VCE(passthru)		///
			Robust			///
			// blank
	local badnames subpop cluster vce robust
	if inlist("`cmdname'","ivreg","regress") {
		local badopts `badopts' hc2 hc3 hascons tsscons	///
			NOHEader DEPname(passthru) plus beta
		local badnames `badnames' hc2 hc3 hasxons tsscons ///
			noheader depname plus beta
	}
	if inlist("`cmdname'","logit","probit") {
		local badopts `badopts' NOCOEf
		local badnames `badnames' nocoef
	}
	if inlist("`cmdname'","glm") {
		local badopts `badopts' IRLS
		local badnames `badnames' irls
	}
	if inlist("`cmdname'", "heckman") {
		local badopts `badopts' TWOstep
		local badnames `badnames' twostep
	}

	// options with side-effects that -svy- needs to be aware of
	if "`cmdname'" == "ivreg" {
		local first FIRST
	}

	syntax name(name=cmdname) [,	///
		crittype(passthru)	///
		SCore(passthru)		///
		STRata(passthru)	/// see _svy_newrule.ado
		PSU(passthru)		/// see _svy_newrule.ado
		FPC(passthru)		/// see _svy_newrule.ado
		TECHnique(passthru)	///
		Log NOLog TRace		///
		COEF			///
		`badopts'		///
		`first'			///
		*			///
	]
	if "`log'`trace'" != "" {
		local options `"`log' `nolog' `trace' `options'"'
	}

	foreach name of local badnames {
		if `"``name''"' != "" {
			local 0 `", ``name''"'
			syntax [, NOT_AN_OPTION ]
		}
	}

	// check for other illegal options; also
	// check that the data is -svyset-
	_svy_newrule , `strata' `psu' `fpc'

	local pseudo	intreg		/// -ml- cmds
			gnbreg		///
			heckman		///
			heckprob	///
			poisson		///
			nbreg		///
			logit		/// built-in cmds
			mlogit		///
			ologit		///
			oprobit		///
			probit		///
			// blank
	if `"`crittype'"' == "" & `: list cmdname in pseudo' {
		local crittype crittype("log pseudolikelihood")
	}

	local cmdopts2 `score'	// start fresh
	local cmdopts2 `cmdopts2' `crittype'
	local cmdopts2 `cmdopts2' `technique'
	if `"`technique'"' != "" {
		local cmdopts2 `technique'
		CheckTechnique vce_oim, `technique'
		if "`vce_oim'" != "" {
			local cmdopts2 `cmdopts2' `vce_oim'
		}
	}
	if inlist("`cmdname'", "ivreg", "regress") {
		local cmdopts2 `cmdopts2' mse1
	}

	sreturn clear
	sreturn local cmdopts1	`", `options'"'
	sreturn local cmdopts2	`"`cmdopts2'"'
	sreturn local log	`log' `trace'

	// special options
	if "`cmdname'" == "ivreg" & "`first'" != "" {
		sreturn local first first
	}
end

program CheckTechnique
	syntax name [, TECHnique(string)]
	local tech : list retok technique
	local bhhh bhhh
	if `:list bhhh == tech' {
		c_local `namelist' vce(oim)
	}
end


exit
