*! version 2.0.2  07sep2005
program define frac_dv, rclass
	version 6
	* 1=normal (1=yes), 2=weight type, 3=nobs, 4=mnlnwt, 5=dist, 
	* 6=glm (1=yes), 7=xtgee (1=yes), 8=qreg (1=yes), 9=scale (for glm).
	* Returns deviance in r(deviance)

	args normal e nobs mnlnwt dist glm xtgee qreg scale

	if `normal' {
		if substr("`e'",1,2)=="iw" {
			ret scalar deviance = /*
			*/ (`nobs'*(log(2*_pi)-`mnlnwt')+e(rss))
		}
		else {
			if e(rss)==0 {
				ret scalar deviance=-1e30
			}
			else ret scalar deviance = /*
			*/ `nobs'*(1+log(2*_pi*e(rss)/`nobs')-`mnlnwt')
		}
	}
	else {
		if `dist'==2 | `dist'==6 { 
			ret scalar deviance = -2*e(ll)
		}
		else if `glm' {
			ret scalar deviance = -2*e(ll)	/* e(deviance)/`scale' */
		}
		else if `xtgee' {
			ret scalar deviance = -e(chi2)
		}
		else if `qreg' {
			ret scalar deviance = /*
			*/ `nobs'*log(e(sum_adev)/e(sum_rdev))
		}
		else 	ret scalar deviance = -2*e(ll)
	}
end
