*! version 1.0.0  10jan2006
* ghk - GHK probit simulator
version 9.0
mata:
 
real scalar ghk(real vector x, real matrix V, real vector opt, real scalar rank, 
		|real vector dfdx, real vector dfdv)
{
	real scalar m, l, a
	real vector opt1, p, d1, d2
	real matrix T, P
	pointer(real vector) vector res

	m = length(x)
	if (rows(V)!=m || cols(V)!=m) {
		errprintf("x is of length %g, but V is %g x %g\n", m, rows(V), cols(V))
		exit(3200)
	}
	a = args()
	if (a != 4 && a != 6) {
		errprintf("ghk() must have 4 or 6 arguments\n")
		exit(3001)
	}
	if ((l=length(opt)) < 2) {
		errprintf("minimum length of the opt vector is 2\n")
		exit(3200)
		
	}
	if (opt[1]!=1 && opt[1]!=2 && opt[1]!=3) {
		errprintf("method option, opt[1], must equal 1, 2, or 3\n")
		exit(3300)
	}
	if (opt[2] <= 0 ) {
		errprintf("number of simulation points option, opt[2], must be greater than 0\n")
		exit(3300)
	}
	if (a==6) opt1 = (1, opt)
	else opt1 = (0, opt)

	if (l>2 && opt[1]<3) {
		opt1[4] = round(opt1[4])
		if (opt1[4] < 1) {
			errprintf("index of the first draw must be greater than 0\n")
			exit(3300)
		}
		opt1[4] = opt1[4] - 1
	}
	if (l > 3) opt1[5] = (opt1[5] != 0)

	res = _ghk(x, V, opt1)
	rank = *res[4]
	if (opt1[1]) {
		p = invorder(*res[3])
		dfdx = (*res[5])[p]
		T = (*res[2])[p,.]
		P = I(m)[p,.]

		pragma unset d1
		pragma unset d2
		ghk_duplower(m, d1, d2)

		dfdv = (*res[6])*qrinv(((T#P)[,d1]+(P#T)[,d2])[d1,])
	}
	return((*res[1])[1])
}

void ghk_duplower(real scalar m, real vector d, real vector dt)
{
        real scalar i, j, k, l

	d = dt = J(m*(m+1)/2,1,.)
        k = l = 0

        for (j=1; j<=m; j++) {
                for (i=j; i<=m; i++) {
			d[++l] = ++k
			dt[l] = (i-1)*m+j
                }
                k = k + j
        }
}

end
