*! version 1.1.11  19apr2007

program define ivprobit, eclass byable(onecall)
	if _by() {
		local BY `"by `_byvars'`_byrc0':"'
	}
	`BY' _vce_parserun ivprobit, unparfirsteq equal unequalfirsteq	///
		mark(CLuster) : `0'
	if "`s(exit)'" != "" {
		exit
	}

	version 8.2

	if replay() {
		if "`e(cmd)'" != "ivprobit" {
			error 301
		}
		if _by() {
			error 190
		}
		if "`e(method)'" == "ml" {
			MLDisplay `0'
		}
		else {
			TSDisplay `0' 
		}
		exit
	}
	`BY' Estimate `0'
end

program define Estimate, eclass byable(recall) sortpreserve
	
	// Portions of syntax parsing code are from ivreg.ado
	local n 0

	gettoken lhs 0 : 0, parse(" ,[") match(paren)
	IsStop `lhs'
	if `s(stop)' { 
		error 198 
	}  
	while `s(stop)'==0 {
		if "`paren'"=="(" {
			local n = `n' + 1
			if `n'>1 {
				capture noi error 198
di as error `"syntax is "(all instrumented variables = instrument variables)""'
				exit 198
			}
			gettoken p lhs : lhs, parse(" =")
			while "`p'"!="=" {
				if "`p'"=="" {
					capture noi error 198
di as error `"syntax is "(all instrumented variables = instrument variables)""'
di as error `"the equal sign "=" is required"'
					exit 198
				}
				local end`n' `end`n'' `p'
				gettoken p lhs : lhs, parse(" =")
			}
			tsunab end`n' : `end`n''
			tsunab exog`n' : `lhs'
		}
		else {
			local exog `exog' `lhs'
		}
		gettoken lhs 0 : 0, parse(" ,[") match(paren)
		IsStop `lhs'
	}
	local 0 `"`lhs' `0'"'

	tsunab exog : `exog'
	tokenize `exog'
	local lhs "`1'"
	local 1 " "
	local exog `*'
	
	// Eliminate vars from `exog1' that are in `exog'
	Subtract inst : "`exog1'" "`exog'"
	
	// `lhs' contains depvar, 
	// `exog' contains RHS exogenous variables, 
	// `end1' contains RHS endogenous variables, and
	// `inst' contains the additional instruments

	// Now parse the remaining syntax
	syntax [if] [in] [fw pw iw / ] , [ Mle TWOstep Robust 	///
		CLuster(varname) SCore(string) FIRST noLOg 	///
		ASIS Level(cilevel) FROM(string)	 	///
		NRTOLerance(string) * ]
	
	local mloptions `"`options'"'
	if _by() {
		_byoptnotallowed score() `"`score'"'
	}
	marksample touse
	markout `touse' `lhs' `exog' `end1' `inst'
	
	// Syntax checking
	if "`mle'" != "" & "`twostep'" != "" {
		di as error "cannot specify both mle and twostep options"
		exit 198
	}
	local estimator "`mle'`twostep'"
	if "`estimator'" == "" {
		local estimator "mle"
	}
	if "`robust'`cluster'" != "" & ///
		`=index("`mloptions'", "vce(")' > 0 {
		if "`cluster'" != "" {
di as error "options vce() and cluster() may not be combined" 
		}
		else {
di as error "options vce() and robust may not be combined"
		}
		exit 198
	}
	if "`estimator'" == "twostep" & ///
"`robust'`cluster'`score'`log'`from'`nrtolerance'`mloptions'" != "" {
di as err "two-step estimator only allows the first, level(), and asis options"
		exit 198
	}
	if "`weight'" != "" { 
		local wgt `"[`weight'=`exp']"' 
	}
	if "`weight'" == "pweight" | "`cluster'" != "" {
		local robust "robust"
	}
	if "`weight'" != "" & "`weight'" != "fweight" & ///
		"`estimator'" == "twostep" {
		di as error "may only use fweights with two-step estimator"
		exit 498
	}
	if "`cluster'" != "" { 
		local clusopt "cluster(`cluster')" 
	} 
	if "`score'" != "" {
		// end1_ct gets redone later after collinearity checking
		local end1_ct : word count `end1'
		local needed = 1 + `end1_ct' + ///
			(`end1_ct'+1)*(`end1_ct'+2)/2 - 1
		local n : word count `score'
		if `n' == 1 & substr("`score'", -1, 1) == "*" {
			local score = substr("`score'",1,length("`score'")-1)
			local scorestr ""
			local scoretmp ""
			forvalues i = 1/`needed' {
				confirm new var `score'`i'
				local scorestr "`scorestr' `score'`i'"
				tempvar score`i'
				local scoretmp "`scoretmp' `score`i''"
			}
			
		}
		else {
			local 0 `score'
			syntax newvarlist
			local score `varlist'
			local n : word count `score'
			if `n' != `needed' {
di as error "number of variables in score() option must be `needed'"
				exit 198
			}
			confirm new var `score'
			local scoretmp ""
			forvalues i = 1/`needed' {
				tempvar score`i'
				local scoretmp "`scoretmp' `score`i''"
			}
			local scorestr "`score'"
		}
		local scoreml "score(`scoretmp')"
	}
	if "`nrtolerance'" == "" {
		local nrtolerance 1e-7
	}

	mlopts mlopts, `mloptions'
	local coll `s(collinear)'
	opts_exclusive "`coll' `twostep'"
	
	// Model identification checks
	CheckVars `lhs' "`exog'" "`end1'" "`inst'" `touse' "`wgt'"
        local exog `s(exog)'
	local inst `s(inst)'
	// Step 2 : call _binperfect and locate perfect predictors
	// This includes exogenous and endogenous vars and insts.
	// Not if asis specified
	tempname rules
	mat `rules' = J(1,4,0)
	if "`asis'" == "" {
		_binperfect `lhs' `exog' `end1' , touse(`touse')
		mat `rules' = r(rules)
		if !(`rules'[1,1] == 0 & `rules'[1,2] == 0 & ///
			`rules'[1,3] == 0 & `rules'[1,4] == 0) {
			noi _binperfout `rules'
			// Remove dropped vars from varlists
			local dropped : rownames(`rules')
			foreach d in `dropped' {
				local exog : subinstr local exog "`d'" ""
				local inst : subinstr local inst "`d'" ""
				local end1 : subinstr ///
					local end1 "`d'" "", count(local c)
				if `c' > 0 {
					di as error ///
					"may not drop an endogenous regressor"
					exit 498
				}
			}
			qui count if `touse'
			if r(N) == 0 {
				exit 2000
			}
			CheckVars `lhs' "`exog'" "`end1'" "`inst'" 	///
				   `touse' "`wgt'"
			local exog `"`s(exog)'"'
			local inst `"`s(inst)'"' 
		}
		// Need to check reduced-form model if two-step est
		if "`twostep'" != "" {
			di as text "Checking reduced-form model..."
			_binperfect `lhs' `inst' `exog', touse(`touse')
			mat `rules' = r(rules)
			if !(`rules'[1,1] == 0 & `rules'[1,2] == 0 & ///
				`rules'[1,3] == 0 & `rules'[1,4] == 0) {
				noi _binperfout `rules'
				// Remove dropped vars from varlists
				local dropped : rownames(`rules')
				foreach d in `dropped' {
					local exog : subinstr local exog "`d'" ""
					local inst : subinstr local inst "`d'" ""
				}
				qui count if `touse'
				if r(N) == 0 {
					exit 2000
				}
			}
		}
	}
	qui count if `touse'
	if r(N) == 0 {
		exit 2000
	}
	
	local lhsname `lhs'
	local lhsstr : subinstr local lhsname "." "_"
	local exogname `exog'
	local end1name `end1'
	local instname `inst'

	_find_tsops `lhs' `exog' `end1' `inst'
	if `r(tsops)' {
		qui tsset
		tsrevar `lhs'
		local lhs `r(varlist)'
		tsrevar `end1'
		local end1 `r(varlist)'
		tsrevar `exog'
		local exog `r(varlist)'
		tsrevar `inst'
		local inst `r(varlist)'
	}
	local exog_ct : word count `exog'
	local end1_ct : word count `end1'
	local inst_ct : word count `inst'
	if `end1_ct' == 0 {
		di as error "no endogenous variables; use {cmd:probit} instead"	
		exit 498
	}
        CheckOrder `end1_ct' `inst_ct'

	tempvar xb	// used later by both estimators
	
	if "`estimator'" == "twostep" {
		// First set up D(Pi)
        	// The selection matrix is just the identity matrix
	        // if we include the exogenous variables after the other insts.
	        local totexog_ct = `exog_ct' + `inst_ct'
        	tempname DPi  
	        mat `DPi' = J(`totexog_ct'+1, `end1_ct'+`exog_ct'+1, 0)
        	mat `DPi'[`inst_ct'+1, `end1_ct'+1] = I(`exog_ct'+1)
	        // Now do the first-stage regressions, fill in DPi and
        	// save fitted values and residuals
	        tempname junk
        	local fitted ""
	        local resids ""
	        local qui "qui"
	        if "`first'" != "" {
	        	local qui ""
	        }
        	local i = 1
        	if `end1_ct' == 1 {
	        	`qui' di "First stage regression"
	        }
	        else {
	        	`qui' di "First stage regressions"
	        }
	        foreach y of local end1 {
        		`qui' regress `y' `inst' `exog' `wgt' if `touse', ///
        			level(`level')
                	mat `junk' = e(b)
	                mat `DPi'[1, `i'] = `junk' '
        	        tempvar fitted`i' resids`i'
                	qui predict double `fitted`i'' if `touse', xb
	                qui predict double `resids`i'' if `touse', residuals
        	        local fitted "`fitted' `fitted`i''"
                	local resids "`resids' `resids`i''"
	                local i = `i' + 1
        	}
		// 2SIV estimates
        	// We also use these 2SIV estimates for exog. test
	        cap qui probit `lhs' `end1' `exog' `resids' ///
         	       `wgt' if `touse'
	        tempname beta2s b2s l2s var2s chi2exog chi2exdf
	        mat `beta2s' = e(b)
	        mat `b2s' = `beta2s'[1, 1..`end1_ct']
	        // Do the exog. test while we're at it.
        	qui test `resids'
	        scalar `chi2exog' = r(chi2)
	        scalar `chi2exdf' = r(df)
	        
                // Next, estimate the reduced-form alpha
                // alpha does not contain the params on `resids'
                // Also get lambda
                cap qui probit `lhs' `inst' `exog' `resids' `wgt' if `touse'
                tempname b alpha lambda
                mat `b' = e(b)
                mat `alpha' = J(1, `totexog_ct'+1, 0)
                mat `alpha'[1, 1] = `b'[1, 1..`totexog_ct']
                mat `alpha'[1, `totexog_ct'+1] = ///   
                        `b'[1, `totexog_ct'+`end1_ct'+1]
                mat `lambda' = `b'[1, `totexog_ct'+1..`totexog_ct'+`end1_ct']

                // Build up the omega matrix
                tempname omega var
                mat `var' = e(V)
                mat `omega' = J(`totexog_ct'+1, `totexog_ct'+1, 0)
                // First term is J_aa inverse, which is cov matrix
                // from reduced-form probit
                mat `omega'[1, 1] = `var'[1..`totexog_ct', 1..`totexog_ct']
                local j = `totexog_ct'+`end1_ct'+1 
                mat `omega'[`totexog_ct'+1, `totexog_ct'+1] = `var'[`j',`j']
                forvalues i = 1/`totexog_ct' {
                        mat `omega'[`totexog_ct'+1, `i'] = `var'[`j', `i']
                        mat `omega'[`i', `totexog_ct'+1] = `var'[`i', `j']
                }
                tempvar ylb
                qui gen double `ylb' = 0
                local i = 1
                foreach var of varlist `end1' {
                        qui replace `ylb' = `ylb' + ///
                                    `var'*(`lambda'[1,`i'] - `b2s'[1, `i']) ///
                                    if `touse'
                        local i = `i' + 1
                }
                qui regress `ylb' `inst' `exog' `wgt' if `touse'
                tempname V
                mat `V' = e(V)
                mat `omega' = `omega' + `V'
                tempname omegai
                mat `omegai' = inv(`omega')
		
                // Newey answer
                tempname finalb finalv
                mat `finalv' = inv(`DPi'' * `omegai' * `DPi')
                mat `finalb' = `finalv' * `DPi'' * `omegai' * `alpha''
                mat `finalb' = `finalb''
                
       		// Do this here before we restripe e(b)
       		// For count of completely determined outcomes
                loc names `end1' `exog' _cons
                mat colnames `finalb' = `names'
	        mat score double `xb' = `finalb' if e(sample)

		// Fill in orig names for end1, exog and inst - timeseries ops.
		foreach x in end1 exog inst {
			local new`x' ``x''
			foreach y of local `x' {
				local j : list posof "`y'" in `x'
				local y2 : word `j' of ``x'name'
				local new`x' : subinstr local new`x' "`y'" "`y2'"
			}
			local `x' `new`x''
		}
                loc names `end1' `exog' _cons
                mat colnames `finalb' = `names'
                mat colnames `finalv' = `names'
                mat rownames `finalv' = `names'
                qui summ `touse' `wgt' , meanonly
                local capn = r(sum)
                eret post `finalb' `finalv', depname(`lhsname') o(`capn') ///
					esample(`touse')
                eret scalar chi2_exog = `chi2exog'
                eret scalar df_exog = `chi2exdf'
                eret scalar p_exog = chiprob(`chi2exdf', `chi2exog')
                qui test `end1' `exog'
                eret scalar chi2 = r(chi2)
                eret scalar df_m = r(df)
                eret scalar p = chiprob(r(df), r(chi2))
		eret local method "twostep"
		eret local instd "`end1'"
		eret local insts "`exog' `inst'"
		eret local depvar "`lhsname' `end1'"
		TSDisplay, level(`level')
		
	}
	else {
		local noi "noi"
		if "`log'" != "" {
			local noi ""
		}
		tempname b0 V0
		if "`from'" == "" {
			// Starting values
			tempname bfrom cholV
			qui `noi' di as text _n "Fitting exogenous probit model"
			cap `noi' probit `lhs' `end1' `exog' `wgt' ///
				if `touse', nocoef
			if _rc {
				di as error "could not find initial values"
				exit 498
			}
			local probcoef_ct `=`end1_ct' + `exog_ct' + 1'
			mat `b0' = e(b)
			if colsof(`b0') != `probcoef_ct' {
				di as text 	///
"regressor dropped by {cmd:probit}; using {cmd:ivreg} for initial values instead"
				cap ivreg `lhs' `exog' (`end1' = `inst')   ///
					`wgt' if `touse'
				local myrc `=_rc'
				mat `b0' = e(b)
				if `myrc' | (colsof(`b0') != `probcoef_ct') {
					di as error	///
					    "could not find initial values"
					exit 498
				}
			}
			cap qui sureg (`end1' = `exog' `inst')
			if _rc {
				di as error "could not find initial values"
				exit 498
			}
			mat `V0' = e(Sigma)
			cap mat `cholV' = cholesky(`V0')
			if _rc {
                                di as error "could not find initial values"
				exit 498
			}
			loc nchol = `end1_ct'*(`end1_ct' + 1) / 2
			mat `V0' = J(1, `nchol', 0)
			loc m = 1
			forv i = 1/`end1_ct' {
				forv j = `i'/`end1_ct' {
					mat `V0'[1, `m'] = `cholV'[`i',`j']
					loc m = `m' + 1
				}
			}
			if `end1_ct' == 1 {
				mat `bfrom' = `b0', e(b), 0, ln(`V0'[1,1])
			}
			else {
				mat `bfrom' = ///
					`b0', e(b), J(1,`end1_ct', 0), `V0'
			}
			local init "`bfrom', copy"
		}
		else {
			local init "`from'"
		}
		loc iveqns ""   // Holds IV equations
		loc covterms ""   // Holds like /s21 /s31 /s32 for cov mat
		loc testcmd ""  // To give to -test- for exog. test
		loc i = 1
		foreach var of varlist `end1' {
			loc iveqns "`iveqns' (`var' : `var' = `exog' `inst')"
			loc ip1 = `i' + 1
			// Only for multiple endog vars:
			loc covterms "`covterms' /s`ip1'1"
			loc testcmd "`testcmd' [s`ip1'1]_b[_cons]"
			loc i = `i' + 1
		}
		if `end1_ct' > 1 {
			forv j = 1/`end1_ct' {
				loc jp1 = `j' + 1
				forv i = `j'/`end1_ct' {
					loc ip1 = `i' + 1
					loc covterms "`covterms' /s`ip1'`jp1'"
				}
			}
		}
		else {  // Fix things up for the one endog var model
			loc covterms "/athrho /lnsigma"
			loc testcmd "[athrho]_b[_cons]"
		}
		qui `noi' di as text _n "Fitting full model"
		// sort so that we can get the cov terms from the
		// last obs. in dataset in lf
		tempvar currsort
		gen long `currsort' = _n
		sort `touse' `currsort'
		glo IV_NEND = `end1_ct'
		if `end1_ct' == 1 {
			ml model lf ivprob_1_lf				///
				(`lhsstr' : `lhs' = `end1' `exog')	///
				`iveqns' `covterms'			///
				`wgt' if `touse' ,			///
			title(Probit model with endogenous regressors)  ///
				maximize `mlopts' `robust' `clusopt' 	///
				search(off) init(`init') `log'		///
				`scoreml' nrtolerance(`nrtolerance') 	///
				collinear
		}
		else {                                    
			ml model lf ivprob_lf				///
				(`lhsstr' : `lhs' = `end1' `exog')	///
				`iveqns' `covterms'			///
				`wgt' if `touse',			///
			title(Probit model with endogenous regressors)	///
				maximize `mlopts' `robust' `clusopt'    ///
				search(off) init(`init') `log'		///
				`scoreml' nrtolerance(`nrtolerance') 	///
				collinear
		}
		qui test `testcmd'
		eret scalar chi2_exog = r(chi2)
		eret scalar endog_ct = `end1_ct'
		eret scalar p_exog = chiprob(1, e(chi2_exog))
		eret local method "ml"
		if "`scorestr'" != "" {
			tokenize `scorestr'
			local i = 1
			while "``i''" != "" {
				rename `score`i'' ``i''
				local i = `i' + 1
			}
			eret local scorevars `scorestr'
		}
		// Do this here before we restripe e(b)
		// For count of completely determined outcomes
		tempname outb
		mat `outb' = e(b)
	        mat score double `xb' = `outb' if e(sample)

		// rename b and V -- time-series operators
		mat `b0' = e(b)
		mat `V0' = e(V)
		local names : colfullnames `b0'
		// Need to do end1 separately, because if an eqn name,
		// must replace . with _
		local newend1 `end1'
		foreach y of local end1 {
			local j : list posof "`y'" in end1
			local y2 : word `j' of `end1name'
			local newend1 : subinstr local newend1 "`y'" "`y2'"
			local y2s : subinstr local y2 "." "_"
			local names : ///
				subinstr local names ":`y'" ":`y2'", all
			local names : ///
				subinstr local names "`y':" "`y2s':", all
		}
		local end1 `newend1'
		foreach x in exog inst {
			local new`x' ``x''
			foreach y of local `x' {
				local j : list posof "`y'" in `x'
				local y2 : word `j' of ``x'name'
				local new`x' : ///
					subinstr local new`x' "`y'" "`y2'"
				local names : ///
					subinstr local names "`y'" "`y2'", all
			}
			local `x' `new`x''
		}
		mat colnames `b0' = `names'
		mat colnames `V0' = `names'
		mat rownames `V0' = `names'
		eret repost b = `b0' V = `V0', rename
		eret local depvar "`lhsname' `end1'"
		eret local instd "`end1'"
		eret local insts "`exog' `inst'"
		// Return Sigma matrix
		tempname sigma
		mat `sigma' = I(`end1_ct'+1)
		if `end1_ct' == 1 {
			mat `sigma'[2,2] = exp([lnsigma]_b[_cons])^2
			mat `sigma'[2,1] = tanh([athrho]_b[_cons])* ///
					   exp([lnsigma]_b[_cons])
			mat `sigma'[1,2] = `sigma'[2,1]
		}
		else {
			loc endp1 = `end1_ct' + 1
			forvalues j = 1/`endp1' {
				forvalues i = `j'/`endp1' {
					if `i'==1 & `j'==1 {
						mat `sigma'[`i',`j']=1
					}
					else {
						mat `sigma'[`i',`j'] = ///
							[s`i'`j']_b[_cons]
					}
				}
			}
			mat `sigma' = `sigma'*`sigma''
		}
		
		eret matrix Sigma = `sigma'
		
		MLDisplay , level(`level') `first'
	}
	macro drop IV_NEND


	// Count number of completely determined outcomes
        // Need to account for fweights if supplied
        tempvar suc fai
        qui gen `suc' = (`xb' > 18)
        if "`weight'" == "fweight" {
           qui replace `suc' = `suc'*`exp'
        }
        qui summ `suc' if e(sample), meanonly
        eret scalar N_cds = r(sum)
        qui gen `fai' = (`xb' < -18)
        if "`weight'" == "fweight" {
           qui replace `fai' = `fai'*`exp'
        }
        qui summ `fai' if e(sample), meanonly
        eret scalar N_cdf = r(sum)

	if "`asis'" != "" {
		eret local asis "asis"
	}
// e(rules) undocumented but needed by predict
	eret matrix rules `rules'
	if "`weight'" != "" {
		eret local wtype "`weight'"
		eret local wexp "= `exp'"
	}
	eret local predict "ivprobit_p"
	eret local cmd "ivprobit"

	ComDetDisp
	

end

program define MLDisplay

	syntax , [ level(cilevel)  first ]
	local en = `e(endog_ct)'
	if "`first'" == "" {
		local neq = 1
	}
	else {
		local neq = 1 + `en'
	}
	if `en' == 1 {
		ml display, level(`level') neq(`neq')		///
			diparm(lnsigma, label("/lnsigma"))	///
			diparm(athrho, label("/athrho"))	///
			diparm(__sep__)				///
			diparm(lnsigma, exp label("sigma"))	///
			diparm(athrho, tanh label("rho"))
	}
	else {
		 ml display, level(`level') neq(`neq')
        } 
	
	di as text "Instrumented:  " _c
	Disp `e(instd)'
	di as text "Instruments:   " _c
	Disp `e(insts)'
	di as text "{hline 78}"
	if `en' == 1 {
		di as text "Wald test of exogeneity (/athrho = 0): chi2(" ///
			as res e(endog_ct) as text ") = " as res %8.2f    ///
			e(chi2_exog) as text _col(59) "Prob > chi2 = "   ///
			as res %6.4f chiprob(e(endog_ct), e(chi2_exog))
	}
	else {
		di as text "Wald test of exogeneity: " _col(30) as text   ///
			"chi2(" as res e(endog_ct) as text ") = " as res  ///
			%8.2f e(chi2_exog) as text _col(59)               ///
			"Prob > chi2 = " as res %6.4f                     ///
			chiprob(e(endog_ct), e(chi2_exog))
	}

end


program define TSDisplay

	syntax , [ level(cilevel) ]
	
	local endog_ct : word count `e(instd)'
	di
	di as text "Two-step probit with endogenous regressors" _c
	di as text _col(51) "Number of obs   = " as res %9.0f e(N)
	di as text _col(51) "Wald chi2(" as res e(df_m) as text ")" _c
	di as text _col(67) "= " as result %9.2f e(chi2)
	di as text _col(51) "Prob > chi2     = " as res %9.4f  ///
		chiprob(e(df_m), e(chi2))
	di
	eret display, level(`level')
	di as text "Instrumented:  " _c
	Disp `e(instd)'
	di as text "Instruments:   " _c
	Disp `e(insts)'
	di as text "{hline 78}"
	di as text "Wald test of exogeneity: " _col(30) as text        ///
		"chi2(" as res `endog_ct' ///
		as text ") = " as res %8.2f e(chi2_exog) as text       ///
		_col(59) "Prob > chi2 = " as res %6.4f                         ///
		chiprob(`endog_ct', e(chi2_exog))

end

// Borrowed from ivreg.ado	
program define IsStop, sclass

	if `"`0'"' == "[" {
		sret local stop 1
		exit
	}
	if `"`0'"' == "," {
		sret local stop 1
		exit
	}
	if `"`0'"' == "if" {
		sret local stop 1
		exit
	}
	if `"`0'"' == "in" {
		sret local stop 1
		exit
	}
	if `"`0'"' == "" {
		sret local stop 1
		exit
	}
	else {
		sret local stop 0
	}

end

// Borrowed from ivreg.ado	
program define Subtract   /* <cleaned> : <full> <dirt> */

	args        cleaned     /*  macro name to hold cleaned list
		*/  colon       /*  ":"
		*/  full        /*  list to be cleaned
		*/  dirt        /*  tokens to be cleaned from full */

	tokenize `dirt'
	local i 1
	while "``i''" != "" {
		local full : subinstr local full "``i''" "", word all
		local i = `i' + 1
	}

	tokenize `full'                 /* cleans up extra spaces */
	c_local `cleaned' `*'

end


// Borrowed from ivreg.ado
program define Disp
        local first ""
        local piece : piece 1 64 of `"`0'"'
        local i 1
        while "`piece'" != "" {
                di as text "`first'`piece'"
                local first "               "
                local i = `i' + 1
                local piece : piece `i' 64 of `"`0'"'
        }
        if `i'==1 { 
		di 
	}

end


// Collinearity checker 
program define CheckVars, sclass

	args lhs exog end1 inst touse wgt

	/* backups */
	local end1_o `end1'
	local exog_o `exog'
	local inst_o `inst'
	
	/* Let X = [endog exog] and W = [exog inst].  Then
	   X'X and W'W must be of full rank */
	quietly {
		/* X'X */
		_rmcoll `end1' `exog' if `touse' `wgt', `coll'
		local noncol `r(varlist)'
		local end1 : list end1 & noncol
		local exog : list exog & noncol
		/* W'W */
		_rmcoll `exog' `inst' if `touse' `wgt', `coll'
		local noncol `r(varlist)'
		local exog : list exog & noncol
		local inst : list inst & noncol
	}
	local dropped : list end1_o - end1
	if `:word count `dropped'' > 0 {
		di as error "may not drop an endogenous regressor"
		exit 498
	}
	foreach type in exog inst {
		local dropped : list `type'_o - `type'
		foreach x of local dropped {
			di as text "note: `x' dropped due to collinearity"
		}
	}

	sret local exog `exog'
	sret local inst `inst'
			
end


program define CheckOrder
	
	args end inst

        if `end' > `inst' {
                di as error "equation not identified; must have at " ///
                        "least as many instruments "
                di as error "not in the regression as there are "    ///
                        "instrumented variables"
                exit 481
        }

end

program define ComDetDisp

        local successes = e(N_cds)
        local failures = e(N_cdf)
        if (`successes' > 0 | `failures' > 0) {
	        di
                // Make sure failure and success singular if appropo
                if (`successes'==1 & `failures'==1) {
                        di as text ///
"note: 1 failure and 1 success completely determined."
                }
                else if (`successes'==1) {   
                        di as text ///
"note: `failures' failures and 1 success completely determined."
                }
                else if (`failures'==1) {
                        di as text ///
"note: 1 failure and `success' successes completely determined."
                }
                else {
                        di as text ///
"note: `failures' failures and `successes' successes completely determined."
                }
        }


end

