*! version 1.0.1  20feb2007
program matrix_input__dlg
	version 9.0
	gettoken cmd : 0, parse(" ,")
	gettoken cmd 0 : 0, parse(" ,")

	local l = length("`cmd'")
	if substr("setLayout",1,`l')==`"`cmd'"' {
		setLayout `0'
	}
	else if substr("syncUpperWithLower",1,`l')=="`cmd'" {
		syncUpper `0'
	}
	else if substr("generateCommand",1,`l')=="`cmd'" {
		generateCommand `0'
	}
	else if substr("generateValidateProgram",1,`l')=="`cmd'" {
		generateValidateProgram `0'
	}
	else if substr("isChangeSyncOk",1,`l')=="`cmd'" {
		isChangeSyncOk `0'
	}
end

program setLayout
	syntax , rows(int) [cols(int -1) symmetric]

	local dlg .matrix_input_dlg
	local rmax ``dlg'.main.sp_rows.max'
	local cmax ``dlg'.main.sp_cols.max' 
	local col_value = ``dlg'.main.sp_cols.value' 
		// the actual value of the spinner
	
	if `cols' == -1 {
		local cols `rows'
	}
	
	// disable columns that are out of range
	forvalues r = `rmax'(-1)1 {
		forvalues c = `cmax'(-1)`=`cols'+1' {
			`dlg'.main.ed_r`r'c`c'.disable
		}
	}
	// disable rows that are out of range	
	forvalues c = `cmax'(-1)1 {
		forvalues r = `rmax'(-1)`=`rows'+1' {
			`dlg'.main.ed_r`r'c`c'.disable
		}
	}
	// disable upper triangle for symmetric matrices
	if "`symmetric'" != "" {
		forvalues c = 2/`cols' {
			forvalues r = 1/`=`c'-1' {
				`dlg'.main.ed_r`r'c`c'.disable
			}
		}
	}	
	
	// enable rows and columns in the specified range	
	forvalues r = 1/`rows' {
		forvalues c = 1/`cols' {
			if "`symmetric'" == "" {
				`dlg'.main.ed_r`r'c`c'.enable
			}
			else {
				if `r' >= `c' {
					`dlg'.main.ed_r`r'c`c'.enable
				}
			}
		}
	}
	//  Avoid race conditions on slow machines. 
	//	(ie. keyboard repeat can cause events to get ahead of stata ado processing)
	`dlg'.main.sp_rows.setvalue `rows'
	`dlg'.main.sp_cols.setvalue `col_value'
end

program syncUpper
	syntax , size(int) 
	local dlg .matrix_input_dlg
	
	forvalues r = 2/`size' {
		forvalues c = 1/`size' {
			if `r' > `c' {
				`dlg'.main.ed_r`c'c`r'.setvalue ///
					"``dlg'.main.ed_r`r'c`c'.value'"
			}
		}	
	}
end

program isChangeSyncOk
	local dlg .matrix_input_dlg
	local size ``dlg'.main.sp_rows.value'
	forvalues r = 2/`size' {
		forvalues c = 1/`size' {
			if `r' > `c' {
				local lowerVal ``dlg'.main.ed_r`r'c`c'.value'
				local upperVal ``dlg'.main.ed_r`c'c`r'.value'
				if "`lowerVal'" != "" & "`upperVal'" != "" {
					if "`lowerVal'" != "`upperVal'" {
						`dlg'.Execute "program showOverrideBox"
						exit -1
					}
				}
			}
		}	
	}	
end

program generateValidateProgram
	syntax , rows(int) cols(int)
	local dlg .matrix_input_dlg
	
	`dlg'.validate.Arrdropall	
	forvalues r = 1/`rows' {
		forvalues c = 1/`cols' {
			`dlg'.validate.Arrpush  "require main.ed_r`r'c`c'"
		}
	}	
end

program generateCommand
	syntax , rows(int) cols(int)
	local dlg .matrix_input_dlg
	local cmdstring cmd

	forvalues r = 1/`rows' {
		if `r' > 1 {
			local command "`command'\\"
		}
		forvalues c = 1/`cols' {
			if `c' > 1 {
				local command "`command',"
			}
			local command "`command'``dlg'.main.ed_r`r'c`c'.value'"
		}
	}
	`dlg'.`cmdstring'.setstring "`command'"
end
