*! version 1.0.9  18jul2005
program define probit_p
	version 6, missing

	syntax [anything] [if] [in] [, SCores * ]
	if `"`scores'"' != "" {
		GenScores `0'
		exit
	}

		/* Step 1:
			place command-unique options in local myopts
			Note that standard options are
			LR:
				Index XB Cooksd Hat 
				REsiduals RSTAndard RSTUdent
				STDF STDP STDR CONstant(varname) 
			SE:
				Index XB STDP CONstant(varname)
		*/
	local myopts Pr
	if `"`e(prefix)'"' != "" {
		local myopts `myopts' RULEs asif xb
	}

		/* Step 2:
			call _propts, exit if done, 
			else collect what was returned.
		*/
	_pred_se "`myopts'" `0'
	if `s(done)' { exit }
	local vtyp  `s(typ)'
	local varn `s(varn)'
	local 0 `"`s(rest)'"'


		/* Step 3:
			Parse your syntax.
		*/
	syntax [if] [in] [, `myopts' noOFFset]
	local type "`xb'`pr'"

	if "`type'"=="" | "`type'"=="pr" {
		if "`type'"=="" {
			di in gr "(option p assumed; Pr(`e(depvar)'))"
		}
		if "`e(prefix)'" != "" {
			quietly _predict `vtyp' `varn' `if' `in', `offset' xb
			_pred_rules `varn', `rules' `asif'
			quietly replace `varn' = norm(`varn')
			_pred_missings `varn'
		}
		else {
			_predict `vtyp' `varn' `if' `in', `offset'
		}
		label var `varn' "Pr(`e(depvar)')"
		exit
	}

	if "`type'"=="xb" {
		quietly _predict `vtyp' `varn' `if' `in', `offset' xb
		_pred_rules `varn', `rules' `asif'
		_pred_missings `varn'
		label var `varn' "Linear prediction"
		exit
	}

	error 198
end

program GenScores, rclass
	version 9, missing
	syntax [anything] [if] [in] [, * ]
	marksample touse
	_score_spec `anything', `options'
	local varn `s(varlist)'
	local vtyp `s(typlist)'
	tempvar xb
	_predict double `xb' `if' `in', xb
	quietly gen `vtyp' ///
	`varn' = normden(`xb')/norm(`xb') if `e(depvar)' != 0
	quietly replace ///
	`varn' = -normden(`xb')/norm(-`xb') if `e(depvar)' == 0
	local cmd = cond("`e(prefix)'"=="svy","svy:","")+"`e(cmd)'"
	label var `varn' "equation-level score from `cmd'"
	return local scorevars `varn'
end
