*! version 1.1.10  04nov2005
program define xtdes, byable(recall)
	version 6, missing

	syntax [if] [in] [, I(varname) Patterns(integer 9) t(varname) Width(integer 100)]

	if `pattern'<0 { error 198 } 
	if `pattern'>=1000 { local pattern . }

	xt_iis `i'
	local ivar "`s(ivar)'"
	xt_tis `t'
	local tvar "`s(timevar)'"

	capture assert `tvar'==int(`tvar')
	if _rc { 
		di in red "`tvar' must take on integer values"
		exit 9
	}
	if `pattern'!=0 {
		capture assert `width'>2
		if _rc {
			di in red "width must be a positive integer greater than 2"
		}
	}
	
	preserve
	marksample touse
	qui keep if `touse'
	capture quietly tab `tvar'
	if _rc==0 & r(r) < 2 {
		di in red "`tvar' must have multiple distinct nonmissing values"
		exit 459
	}
	
	tempvar id tid marker cum cnt ncnt tot T_i dtv
	tempname val1 val2 valn tval1 tval2 tvaln
	di
	quietly { 
		keep `ivar' `tvar'

					/* get sort tvar out of the way */
		sort `tvar'
		by `tvar': gen int `tid' = 1 if _n==1
		replace `tid' = sum(`tid')
		local T = `tid'[_N]
		summ `tvar', meanonly
		scalar `tval1' = r(min)    
		scalar `tvaln' = r(max)     
		summ `tvar' if `tvar'>`tval1', meanonly
		scalar `tval2' = r(min)    
		local tv0 = `tval1' 
		local tv1 = `tvaln' 
		gen int `dtv'=cond(`tvar'-`tvar'[_n-1]==0,.,`tvar'-`tvar'[_n-1])
		summ `dtv', meanonly
		drop `dtv'
		local dtv = r(min)    
		local dtv1 = r(min)
		if `pattern'!=0 {
			if int((`tvaln'-`tval1')/`dtv') + 1 > `width' {
				local dtv = int((`tvaln'-`tval1')/(`width'-1))
			}
		}
					/* from now on, sorted by ivar tvar */
		sort `ivar' `tvar'
		by `ivar': gen long `id' = 1 if _n==1
		replace `id' = sum(`id')
		local n = `id'[_N]
		summ `ivar', meanonly
		scalar `val1' = r(min)    
		scalar `valn' = r(max)    
		summ `ivar' if `ivar'>`val1', meanonly
		scalar `val2' = r(min)     

		by `ivar': gen int `T_i' = _N if _n==_N

		local skip = 8 - length("`ivar'")
		noi di in gr _skip(`skip') "`ivar':  " /*
			*/ in ye `val1' in gr ", " in ye `val2' /*
			*/ in gr ", ..., " in ye `valn' in gr /*
			*/ _col(62) "n =" in ye %11.0f `n'

		capture by `ivar' `tvar': assert _N==1
		if _rc { local unique 0 } 
		else 	local unique 1


		local skip = 8 - length("`tvar'")
		noi di in gr _skip(`skip') "`tvar':  " /*
			*/ in ye `tval1' in gr ", " in ye `tval2' /*
			*/ in gr ", ..., " in ye `tvaln' in gr /*
			*/ _col(62) "T =" in ye %11.0f `T'

		if `dtv'==1 {
			noi di in gr _col(12) "Delta(`tvar') = " in ye `dtv' /*
			*/ in gr "; (" `tvaln' "-" `tval1' ")+1 = " /*
			*/ in ye `tvaln'-`tval1'+1
		}
		else if `dtv'==`dtv1' {
			noi di in gr _col(12) "Delta(`tvar') = " in ye `dtv' /*
			*/ in gr "; (" `tvaln' "-" `tval1' ")/" `dtv' /*
			*/ " + 1 = " /*
			*/ in ye (`tvaln'-`tval1')/`dtv'+1
		}
		else  {
			local del = int((`tvaln'-`tval1')/`dtv')+1 
			noi di in gr _col(12) "Delta(`tvar') = " in ye `dtv' /*
			*/ in gr "; int((" `tvaln' "-" `tval1' ")/" `dtv' /*
			*/ ") + 1 = " /*
			*/ in ye `del'
		}


		if `unique' {
			noi di in gr _col(12) /* 
*/ "(`ivar'*`tvar' uniquely identifies each observation)"
		}
		else {
			noi di in gr _col(12) /*
*/ "(`ivar'*`tvar' does not uniquely identify observations)"
		}

		noi di _n in gr "Distribution of T_i:   min      5%     25%       50%       75%     95%     max"

		summ `T_i',  detail 
		noi di in ye _col(21) %6.0f r(min) "  " /* 
			*/ %6.0f r(p5) "  " /*
			*/ %6.0f r(p25) "    " /* 
			*/ %6.0f r(p50) "    " /* 
			*/ %6.0f r(p75) "  " /* 
			*/ %6.0f r(p95) "  " /*
			*/ %6.0f r(max) 

		drop `T_i'

		if `pattern'==0 { exit }

		local l = `tv0' - .5
		local i = 0
		while `l'<`tv1' {
			local u  = `l' + `dtv' 
			gen int _T`++i' = 1 if `l'<`tvar' & `tvar'<=`u'
			by `ivar': replace _T`i' = sum(_T`i')
			local list "`list' _T`i'"
			local l = `l' + `dtv'	
		}
		local nT = `i'
		by `ivar': keep if _n==_N
		keep `list' 
		sort `list'
		by `list': gen long `cnt' = _N
		by `list': keep if _n==_N
		gen long `ncnt' = -`cnt'
		sort `ncnt' `list'
		drop `ncnt'
	}

	local dup = max(int((`tv1'-`tv0')/`dtv'+1.5),length("Pattern"))
	di in smcl in gr _n _col(6) /*
		*/ "Freq.  Percent    Cum. {c |}  Pattern" _n /*
		*/ " {hline 27}{c +}{c -}{c -}{hline `dup'}"

	gen long `cum' = sum(`cnt') 
	local N = min(_N,`pattern')  
	forvalues i = 1/`N' { 
		di in smcl in ye /*
			*/ %9.0f `cnt'[`i'] %10.2f 100*`cnt'[`i']/`cum'[_N] /*
			*/ %8.2f 100*`cum'[`i']/`cum'[_N] in gr " {c |}  " _c
		forvalues j = 1/`nT' { 
			if _T`j'[`i']==0 { di in ye "." _c }
			else if _T`j'[`i']<=9 { di in ye %1.0f _T`j'[`i'] _c } 
			else 	di in ye "X" _c
		}
		di
	}
	if `N'<_N { 
		di in smcl in ye %9.0f `cum'[_N]-`cum'[`N'] %10.2f /*
		*/ 100*(`cum'[_N]-`cum'[`N'])/`cum'[_N] /*
		*/ %8.2f 100 in gr " {c |} (other patterns)"
	}

	di in smcl in gr " {hline 27}{c +}{c -}{c -}{hline `dup'}"

	forvalues j = 1/`nT' { 
		gen long `tot' = sum(_T`j')
		qui replace _T`j' = cond(`tot'>9,10,`tot')
		drop `tot'
	}
	di in smcl in ye /*
	*/ %9.0f `cum'[_N] %10.2f 100 _skip(8) in gr " {c |}  " _c
	forvalues j = 1/`nT' { 
			if _T`j'[_N]==0 { di in ye "." _c }
/*
			else if _T`j'[_N]<=9 { di in ye %1.0f _T`j'[_N] _c } 
*/
			else 	di in ye "X" _c
	}
	di
end
