*! version 2.4.16  14jul2006
program define xtreg_ml, eclass
	_vce_parserun xtreg, panel mark(I) : `0'
	if "`s(exit)'" != "" {
		exit
	}
        version 6, missing
	if replay() {
                if "`e(model)'" != "ml" {
                        noi di in red "results for xtreg not found"
                        exit 301
                }
                Display `0'
                exit
        }
        Estimate `0'
end


program define Estimate, eclass
	#delimit ;
	syntax [varlist(ts)] [if] [in] [iweight] 
			[, mle I(varname) RE SKIP Level(cilevel) noREFINE
			noCONstant OFFset(string) FROM(string) noLOg noDISP *] ;
	#delimit cr

	mlopts mlopt, `options'
	if "`s(collinear)'" != "" {
		di as err "option collinear not allowed"
		exit 198
	}
        local disparg "level(`level')"

	xt_iis `i'
	local ivar "`s(ivar)'"

	if "`offset'" != "" {
		tempvar ovar
		confirm var `offset'
		gen double `ovar' = `offset'
		local oarg "offset(`ovar')"
	}

	quietly {
		tempvar touse
		mark `touse' `if' `in' [`weight'`exp']
		markout `touse' `varlist' `ovar'
		markout `touse' `ivar', strok
		capture tsset
		if _rc == 0 {
			local ivar `r(panelvar)'
			local tvar `r(timevar)'
		}
		tsunab varlist : `varlist'
		noi _rmcoll `varlist'
		local varlist "`r(varlist)'"
		parse "`varlist'", parse(" ") 
		local olddep "`1'"
		tsrevar `olddep'
		local dep `r(varlist)'
		mac shift
		local oldind "`*'"
		tsrevar `oldind'
		local ind `r(varlist)'

		count if `touse'
		noi _rmcoll `ind' if `touse' , `constan'
		local ind "`r(varlist)'"
		local p : word count `ind' 

                sort `touse' `ivar'
                if "`weight'" != "" {
                        tempvar wv
                        gen double `wv' `exp'
                        _crcchkw `ivar' `wv' `touse'
                        drop `wv'
                }

		reg `dep' `ind' [`weight'`exp'] if `touse', `oarg' `constan'
		local llprob = e(ll)  
		local s2     = e(rmse)^2
		tempvar z
		predict double `z' if `touse', resid

		local olddepn : subinstr local olddep "." "_"
		local k 1
		while `k' <= `p' {
			local wrd : word `k' of `oldind'
			local names "`names' `olddepn':`wrd'"
			local k = `k'+1
		}
                if "`constan'" == "" {
                        local names "`names' `olddepn':_cons sigma_u:_cons"
			local names "`names' sigma_e:_cons"
                        local p = `p' + 1
                }
                else {
			local names "`names' sigma_u:_cons sigma_e:_cons"
			local skip "skip"
		}

		if "`ind'" == "" { local skip "skip" }

		tempvar t T 
		sort `touse' `ivar'
		by `touse' `ivar': gen int `t' = _n if `touse'
                by `touse' `ivar': gen int `T' = _N if `touse'
                by `touse' `ivar': replace `z' = cond(_n==_N, sum(`z'), .)
                replace `z' = sum(`z'*`z'/`T') if `touse'

                summarize `T' if `touse' & `ivar'~=`ivar'[_n-1], meanonly
		local ng = r(N)
		local g1 = r(min)
		local g2 = r(mean)
		local g3 = r(max)

                local su2 = max(0, (`z'[_N]/r(N)-`s2')/(r(mean)-1))
		drop `z' `t' 

		local t2 = sqrt(`su2')
		local t1 = sqrt(max(0,`s2'-`su2'))

		tempname beta 
		if "`from'" == "" {
			mat `beta' = get(_b)
			mat coleq `beta' = `dep'
			tempname rho
			mat `rho' = (`t2',`t1')
			mat colnames `rho' = sigma_u:_cons sigma_e:_cons
			mat `beta' = `beta',`rho'
		} 
		else {
			mat `beta' = `from'
                        local skip "skip"
                        local refine "norefine"
		}

		tempvar w
		if "`weight'" == "" {
			gen double `w' = 1 if `touse'
		}
		else {
			gen double `w' `exp' if `touse'
		}
		
		summ `dep' [aw=`w'*`t1'*`t1'/(`T'*`t2'*`t2'+`t1'*`t1')] /*
			*/ if `touse', meanonly
		drop `T'
		tempname beta0
		mat `beta0' = (r(mean),`t2',`t1')

		sort `touse' `ivar' `dep' `ind'
		tempvar p
		gen long `p' = _n*`touse'
		summ `p' if `touse'
		local j0 = r(min)
		local j1 = r(max)

		if "`log'" == "" { local lll "noisily" }
		else             { local lll "quietly" }
	}
	if "`skip'" == "" {
		`lll' di in green _n "Fitting constant-only model:"
		_XTRENORM `dep' in `j0'/`j1', i(`ivar') w(`w') `oarg' /*
			*/ nodisplay b(`beta0') `options' /*
			*/ `clopt' regress `log' `refine' 
		local ll0 = e(ll)
		local llarg "ll_0(`ll0')"
		`lll' di in green _n "Fitting full model:" 
	}
	_XTRENORM `dep' `ind' in `j0'/`j1', i(`ivar') w(`w') `oarg' /*
		*/ `llarg' b(`beta') `options' `clopt' /*
		*/ regress `log' `constan' `refine'
	est local cmd
	est local distrib "Gaussian"
	est local title   "Random-effects ML regression"
	est local model   ml 
	est local wtype   "`weight'"
	est local wexp    "`exp'"

	est scalar N_g    = `ng'
	est scalar g_min  = `g1'
	est scalar g_avg  = `g2'
	est scalar g_max  = `g3'
	tempname b v bsu
	mat `b' = get(_b)
	mat `v' = get(VCE)
	local nc1 = colsof(`b')
	local nc = `nc1'-1
	local su = `b'[1,`nc']
	if `su' < 0 {
		mat `b'[1,`nc'] = -`su' 
		local i 1
		while `i' < `nc' {
			mat `v'[`i',`nc'] = -`v'[`i',`nc']
			mat `v'[`nc',`i'] = `v'[`i',`nc']
			local i = `i'+1
		}
		mat `v'[`nc',`nc1'] = -`v'[`nc',`nc1']
		mat `v'[`nc1',`nc'] = `v'[`nc',`nc1']
	}
	local nc = `nc1'
	local se = `b'[1,`nc']
	if `se' < 0 {
		mat `b'[1,`nc'] = -`se' 
		local i 1
		while `i' < `nc' {
			mat `v'[`i',`nc'] = -`v'[`i',`nc']
			mat `v'[`nc',`i'] = `v'[`i',`nc']
			local i = `i'+1
		}
	}
	mat colnames `b' = `names'
	mat colnames `v' = `names'
	mat rownames `v' = `names'
	est post `b' `v', depname(`olddep') noclear

        if "`llprob'" != "" {
                est scalar ll_c   = `llprob'
		est scalar chi2_c = cond([sigma_u]_b[_cons]<1e-5, 0, /*
                        */ abs(-2*(e(ll_c)-e(ll))))
                est local chi2_ct "LR"
	}
	else {
                qui test [sigma_u]_cons = 0
                est scalar chi2_c  = r(chi2)
                est local chi2_ct  "Wald"
	}

        est scalar sigma_u = [sigma_u]_b[_cons]
        est scalar sigma_e = [sigma_e]_b[_cons]
        est scalar rho = e(sigma_u)^2/(e(sigma_u)^2+e(sigma_e)^2)

	if (1) /* _caller() < 6 */ { /* Double saves */
		global S_E_cmd	"`e(cmd)'"
		global S_E_cmd2	"`e(cmd2)'"
		global S_E_llp	"`e(ll_c)'"
	}
	est local predict xtrefe_p
	est local ivar    "`ivar'"
	est local offset1 "`offset1'"
	est local cmd     "xtreg"
	est local depvar  "`olddep'"
	if "`disp'" == "" {
		DispTbl, `disparg'
		DispLR
	}
end


program define DispTbl
	syntax [, Level(cilevel)]

        tempname b
        mat `b' = get(_b)
        local su = [sigma_u]_b[_cons]
        local se = [sigma_e]_b[_cons]
        local bb = `su'^2/(`su'^2+`se'^2)

	_crcphdr
	est di, first plus level(`level')
	tempname gu ge std_gu std_ge lu le uu ue z

	scalar `gu' = ln(`su') 
	scalar `ge' = ln(`se') 

	scalar `z'  = - invnorm((1-(.01*`level'))/2)

	scalar `std_gu' = (1/`su')*_se[sigma_u:_cons]
	scalar `std_ge' = (1/`se')*_se[sigma_e:_cons]

	scalar `lu'     = exp(`gu'-`z'*`std_gu')
	scalar `uu'     = exp(`gu'+`z'*`std_gu')

	scalar `ue'     = exp(`ge'+`z'*`std_ge')
	scalar `le'     = exp(`ge'-`z'*`std_ge')

	di in smcl as txt "    /sigma_u {c |}" as res			///
		_col(17) %9.0g `su'					///
		_col(28) %9.0g _se[sigma_u:_cons]			///
		"{col 56}  " %9.0g `lu' 				///
		"{col 68}  " %9.0g `uu' 

	di in smcl as txt "    /sigma_e {c |}" as res 			///
		_col(17) %9.0g `se'					///
		_col(28) %9.0g _se[sigma_e:_cons]			///
		"{col 56}  " %9.0g `le' 				///
		"{col 68}  " %9.0g `ue' 

	_diparm sigma_u sigma_e, label(rho) func(@1^2/(@1^2+@2^2)) /*
		*/ der( 2*@1*(@2/(@1^2+@2^2))^2 -2*@2*(@1/(@1^2+@2^2))^2 ) /*
		*/ ci(probit)
/*
        di in smcl in gr "     rho {c |} "   in ye %10.0g `bb' /*
		*/ in gr "   (fraction of variance due to u_i)"
*/
	di in gr in smcl "{hline 13}{c BT}{hline 64}"
end
	
program define Display
	DispTbl `0'
	DispLR
end

program define DispLR
	if "`e(ll_c)'" == "" {
		*di in green "Wald test of sigma_u=0:             " _c
		*di in green "chi2(" in ye "1" in gr ") = " /*
                */ in ye %8.2f e(chi2_c) _c
        	*di in green "    Prob > chi2 = " in ye %6.4f /*
                */ chiprob(1,e(chi2_c))
	}
	else {
		tempname pval
                scalar `pval' =  chiprob(1, e(chi2_c))*0.5
                if e(chi2_c)==0 { scalar `pval'= 1 }
		if ((e(chi2_c) > 0.005) & (e(chi2_c)<1e4)) | (e(chi2_c)==0) {
                        local fmt "%8.2f"
                }
                else    local fmt "%8.2e"
                di in green "Likelihood-ratio test of sigma_u=0: " _c
                di in green in smcl "{help j_chibar##|_new:chibar2(01)=}" /*
                        */ in ye `fmt' e(chi2_c) _c
                di in green " Prob>=chibar2 = " in ye %5.3f /*
                        */ `pval'
	}
end
