*! version 1.0.1  23aug2006
program xtset
	version 9.2
	syntax [varlist(numeric max=2 default=none)] [,*]

	local nvars : list sizeof varlist
	if `nvars' == 2 {
		tsset `0'
	}
	else if `nvars' == 1 {
		PanelSet `0'
	}
	else {
		syntax [, clear]
		if "`clear'" != "" {
			tsset, clear
		}
		else {
			if `"`: char _dta[_TStvar]'"' == "" {
				PanelSet
			}
			else	tsset
		}
	}
end

program PanelSet, rclass sortpreserve
	syntax [varlist(max=1 default=none)]
	if "`varlist'" != "" {
		tsset, clear
		char _dta[iis] `varlist'
		char _dta[_TSpanel] `varlist'
	}
	else {
		local varlist : char _dta[_TSpanel]
		if "`varlist'" == "" {
			local varlist : char _dta[iis]
		}
	}
	if "`varlist'" == "" {
		di as err "panel variable not set, use -xtset varname ...-"
		exit 459
	}
	sort `varlist'
	tempvar nobs
	quietly by `varlist': gen `nobs' = _N
	capture assert `nobs' == `nobs'[1]
	if c(rc) {
		local bal unbalanced
	}
	else	local bal balanced
	di as txt _col(8) "panel variable:  " as res "`varlist' (`bal')"
	return local balanced `bal'
	return local panelvar `varlist'
	sum `varlist', meanonly
	return scalar imin = r(min)
	return scalar imax = r(max)
end
